// Mop_testDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Mop_test.h"
#include "Mop_testDlg.h"

#include <iostream>
#include <fstream>
#include <time.h>
using namespace std;


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern void MopTest();
extern int bIns;
extern int bExtOut;
extern int bMinOut;
extern int bAllXOut;
extern int bBegState;
extern int iSchType;
extern int bQOut;
extern char FNameMop[50];
extern char FNameEntr[50];
extern char FNameBegState[50];

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMop_testDlg dialog

CMop_testDlg::CMop_testDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMop_testDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMop_testDlg)
	m_bIns = FALSE;
	m_FNameMop = _T("");
	m_FNameEntr = _T("");
	m_bAllXOut = FALSE;
	m_bBegState = FALSE;
	m_FNameBegState = _T("");
	m_Report = (bExtOut)? 0: ((bMinOut)? 2:1);
	m_SchType = iSchType;
	m_bQOut = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMop_testDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMop_testDlg)
	DDX_Control(pDX, IDC_CHECK3, m_check3);
	DDX_Control(pDX, IDC_EDIT3, m_edit3);
	DDX_Check(pDX, IDC_CHECK1, m_bIns);
	DDX_Text(pDX, IDC_EDIT1, m_FNameMop);
	DDV_MaxChars(pDX, m_FNameMop, 40);
	DDX_Text(pDX, IDC_EDIT2, m_FNameEntr);
	DDV_MaxChars(pDX, m_FNameEntr, 40);
	DDX_Check(pDX, IDC_CHECK3, m_bAllXOut);
	DDX_Check(pDX, IDC_CHECK4, m_bBegState);
	DDX_Text(pDX, IDC_EDIT3, m_FNameBegState);
	DDV_MaxChars(pDX, m_FNameBegState, 40);
	DDX_Radio(pDX, IDC_RADIO1, m_Report);
	DDX_Radio(pDX, IDC_RADIO4, m_SchType);
	DDX_Check(pDX, IDC_CHECK5, m_bQOut);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMop_testDlg, CDialog)
	//{{AFX_MSG_MAP(CMop_testDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CHECK4, OnCheck4)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMop_testDlg message handlers

BOOL CMop_testDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_bIns      = bIns;
	m_bAllXOut  = bAllXOut;
	m_bBegState = bBegState;
  m_bQOut     = bQOut;
	m_FNameMop  = "D_trig1";
	m_FNameEntr = "Entries1";
	m_FNameBegState="Beg_state";
	m_edit3.EnableWindow(m_bBegState);
	m_check3.EnableWindow(m_bIns);
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMop_testDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMop_testDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMop_testDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMop_testDlg::OnOK() 
{
	// TODO: Add extra validation here
	UpdateData(TRUE);

	char s[100];
	ifstream ifs1(m_FNameMop);
	if (!ifs1)
	{
		wsprintf(s," %s  ",m_FNameMop);
		AfxMessageBox(s,MB_ICONQUESTION); return;
	}
	ifstream ifs2(m_FNameEntr);
	if (!ifs2)
	{
		wsprintf(s," %s  ",m_FNameEntr);
		AfxMessageBox(s,MB_ICONQUESTION); return;
	}
	ifstream ifs3(m_FNameBegState);
	if (m_bBegState && !ifs3)
	{
		wsprintf(s," %s  ",m_FNameBegState);
		AfxMessageBox(s,MB_ICONQUESTION); return;
	}

	bIns      = m_bIns;
	bAllXOut  = m_bAllXOut;
	bBegState = m_bBegState;
	bExtOut   = (m_Report==0);
	bMinOut   = (m_Report==2);
  iSchType  = m_SchType;
  bQOut     = m_bQOut;
	strcpy(FNameMop, m_FNameMop);
	strcpy(FNameEntr, m_FNameEntr);
	strcpy(FNameBegState, m_FNameBegState);

	time_t t_beg=time(NULL);

	MopTest();

	time_t tt = time(NULL)-t_beg;
	int hh=tt/3600L, mm=(tt-hh*3600L)/60L, ss=(tt-hh*3600L-mm*60L);
	wsprintf(s,"    %s\n : %02d:%02d:%02d",m_FNameMop+".out",hh,mm,ss);
	AfxMessageBox(s);
	
	//CDialog::OnOK();
}

void CMop_testDlg::OnCheck4() 
{
	UpdateData(TRUE);
	m_edit3.EnableWindow(m_bBegState);
}

void CMop_testDlg::OnCheck1() 
{
	UpdateData(TRUE);
	m_check3.EnableWindow(m_bIns);
}
